'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _http = require('http');

var _url = require('url');

var _incomming = require('./incomming');

var _incomming2 = _interopRequireDefault(_incomming);

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HttpProxy = function (_EventEmitter) {
    _inherits(HttpProxy, _EventEmitter);

    function HttpProxy(option, server) {
        _classCallCheck(this, HttpProxy);

        var _this = _possibleConstructorReturn(this, (HttpProxy.__proto__ || Object.getPrototypeOf(HttpProxy)).call(this));

        _this.option = _this.adaptMock(option);
        if (server) {
            _this.server = (0, _http.createServer)(function (req, res) {
                _this.req = req;
                _this.res = res;

                _this.proxy(req, res, option, _this);
            });
        }
        return _this;
    }

    _createClass(HttpProxy, [{
        key: 'adaptoption',
        value: function adaptoption(option) {
            if (!option.target) {}

            this.adaptMock(option);
            this.adaptTarget(option);

            return option;
        }
    }, {
        key: 'adaptTarget',
        value: function adaptTarget(option) {
            if (!option.target) {
                return;
            }

            var target = {
                host: '',
                hostname: '',
                port: '80',
                path: '/',
                protocol: 'http:'
            };
            var urlInfo = typeof option.target === 'string' ? new _url.URL(option.target) : option.target;

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = Object.keys(target)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var key = _step.value;

                    target[key] = urlInfo[key];
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            option.target = target;
        }
    }, {
        key: 'adaptMock',
        value: function adaptMock(option) {
            var _this2 = this;

            if (!option.mock) {
                return;
            }

            var mock = option.mock;
            var base = mock.base || process.cwd();
            var rules = mock.rules;

            rules.forEach(function (rule) {
                rule.from = _this2.ensureUrlPrefix(rule.from);
                rule.to = _this2.ensureUrlPrefix(rule.to);
            });

            rules.sort(function (a, b) {
                return a.from.split('/').length - b.from.split('/');
            });

            option.rules = { base: base, rules: rules };
        }
    }, {
        key: 'ensureUrlPrefix',
        value: function ensureUrlPrefix(url) {
            if (url.indexOf('/') !== 0 && url.indexOf('.') !== 0) {
                url = '/' + url;
            }
            return url;
        }

        //供中间件使用的代理函数

    }, {
        key: 'proxy',
        value: function proxy(req, res, option) {
            if (option) {
                this.adaptoption(option);
            }
            (0, _incomming2.default)(req, res, option, this);
        }
    }, {
        key: 'listen',
        value: function listen(port) {
            this.server.listen(port, function (e) {
                if (e) {
                    return console.error(e);
                }

                console.log('proxy server is on http://localhost:' + port);
            });
            return this;
        }
    }]);

    return HttpProxy;
}(_events2.default);

exports.default = HttpProxy;